// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>

namespace verifone_sdk {

class Basket;
class BasketAdjustedEventResponse;
class BasketAdjustment;
class Transaction;

/**
 * When the basket is adjusted by other applications in response to the
 * {@link com.verifone.commerce.triggers.BasketAdjustmentRequest} Trigger, this event is sent to
 * allow the recipient to decide which adjustments will be actually applied and which will not.
 */
class BasketAdjustedEvent {
public:
    virtual ~BasketAdjustedEvent() {}

    /** The constant event type for basket adjustment event. */
    static std::string const TYPE;

    /** Returns the message associated with the event, */
    virtual std::optional<std::string> getMessage() const = 0;

    /** Get the session ID for the session which triggered this event. */
    virtual std::optional<std::string> getSessionId() const = 0;

    /**
     * Returns the response type, generally a copy of the event type, or otherwise linked to the
     * type of event that generated this response.
     */
    virtual std::optional<std::string> getType() const = 0;

    /** Returns the status of the event, non-zero if it encountered an error during handling */
    virtual int32_t getStatus() const = 0;

    /** Returns event id from event */
    virtual std::optional<std::string> getEventId() const = 0;

    /** Returns invoice id from event */
    virtual std::optional<std::string> getInvoiceId() const = 0;

    /** Return Transaction from event */
    virtual std::shared_ptr<Transaction> getTransaction() const = 0;

    /** Get the original basket without adjustments. */
    virtual std::shared_ptr<Basket> getOriginalBasket() const = 0;

    /** Get the adjustments that are proposed. */
    virtual std::shared_ptr<BasketAdjustment> getAdjustments() const = 0;

    /**
     * Generates a Basket Adjusted Response object to send through
     * {@link TransactionManager#sendEventResponse(CommerceResponse)}.
     * @return The {@link Response} concrete class.
     */
    virtual std::shared_ptr<BasketAdjustedEventResponse> generateBasketAdjustedEventResponse() const = 0;
};

}  // namespace verifone_sdk
